/*
 * fix.c
 * 7/20/89
 * Change MIDI data files to new format.
 */

#include <stdio.h>
#include "midi.h"

extern char *strcpy();

#define	NFNAME	128
#define	TBUFN	30000
unsigned char tbuf[TBUFN];

int
error (s) char *s;
{
	fprintf(stderr, "fix: %r\n", &s);
	exit(1);
}

/*
 * Load file 's' to track 'tp'.
 * Return 1 for success, 0 for failure.
 * Suppress the "not found" error message if flag.
 */
int
load1(tp, s) register TRACK *tp; char *s;
{
	register unsigned int size;
	register FILE *ifp;

	if ((ifp = fopen(s, "rb")) == NULL)
		return 0;
	if (fread(tp, sizeof(TRACK), 1, ifp) != 1)
		error("read error");
	size = tp->t_size;
	if (size > TBUFN)
		error("file \"%s\" too big", s);
	printf("Load from file \"%s\", size=%d\n", s, size);
	tp->t_buf = tbuf;
	if (fread(tbuf, 1, size, ifp) != size)
		error("read error");
	if (fclose(ifp) == EOF)
		error("cannot close input file");
	return 1;
}

/*
 * Save a track to a FILE.
 * Return success or failure.
 */
int
save1(tp, i, ofp) register TRACK *tp; int i; register FILE *ofp;
{
	register unsigned int usize;

	if (fwrite(&i, sizeof(int), 1, ofp) != 1)
		error("write error");
	if (fwrite(tp, sizeof(TRACK), 1, ofp) != 1)
		error("write error");
	usize = tp->t_size;
	if (fwrite(tbuf, 1, usize, ofp) != usize)
		error("write error");
}

main(argc, argv) int argc; char *argv[];
{
	register int i, t, flag;
	unsigned int osize;
	int n;
	FILE *ofp;
	char buf[NFNAME];
	TRACK tr;

	for (i = 1; i <= argc - 1; i++) {
		if ((ofp = fopen(argv[i], "wb")) == NULL)
			error("cannot open output file \"%s\"\n", argv[i]);
		n = MT_MAGIC;
		if (fwrite(&n, sizeof(int), 1, ofp) != 1)
			error("write error");
		osize = sizeof(int);
		n = strlen(argv[i]);
		strcpy(buf, argv[i]);
		buf[n] = '.';
		buf[n+1] = 't';
		buf[n+3] = '\0';
		for (flag = 0, t = 1; t <= NTRACKS; t++) {
			buf[n+2] = '0' + t;
			if (load1(&tr, &buf[0])) {
				osize += sizeof(int) + sizeof(TRACK) + tr.t_size;
				save1(&tr, t, ofp);
				flag = 1;
			}
		}
		if (fclose(ofp) == EOF)
			error("cannot close output file \"%s\"", argv[i]);
		printf("Output file size=%d\n", osize);
		if (!flag)
			error("files \"%s.t?\" not found\n", argv[i]);
	}
	exit(0);
}

/* end of fix.c */
