/*
 * patch.c
 * Dump a D-10 patch.
 */

#include <stdio.h>
#define	PSIZE	0x26
unsigned char	buf[PSIZE];

main(argc, argv) int argc; char *argv;
{
	register int i;

	if (argc == 1) {
		for (i = 0; i <128; i++) {
			sprintf(buf, "patch%03d", i);
			printf("Patch %c%c%c midi=%d ",
				i < 64 ? 'A' : 'B',
				((i % 64) / 8) + '1',
				(i % 8) + '1',
				i);
			patch(buf);
		}
	} else
		patch(argv[1]);
	exit(0);
}

patch(s) char *s;
{
	register FILE *fp;
	register int c, i;
	register unsigned char *bp;

	if ((fp = fopen(s, "rb")) == NULL) {
		printf("open error on \"%s\"\n", s);
		exit(1);
	} else if (fread(buf, PSIZE, 1, fp) != 1) {
		printf("read error\n");
		exit(1);
	} else if ((c = getc(fp)) != EOF) {
		printf("expected EOF but read %x\n", c);
		exit(1);
	} else if (fclose(fp) == EOF) {
		printf("close error\n");
		exit(1);
	}
	printf("\"");
	for (bp = &buf[0x15], i = 0; i < 16; i++)
		printf("%c", *bp++);
	printf("\":\n");
	c = buf[0];
	printf("  %s ", c==0 ? "Whole" : c==1 ? "Dual " : "Split");
	printf("split=%d rtype=%d rtime=%d rlevel=%d bal=%d level=%d\n",
		buf[1], buf[0x10]+1, buf[0x11]+1, buf[0x12], buf[0x13], buf[0x14]);
	printf("  Upper: ");
	c = buf[4];
	printf("%c%02d ", c==0 ? 'a' : c==1 ? 'b' : c==2 ? 'i' : 'r', buf[5]+1);
	printf("shift=%d tune=%d bender=%d assign=%d reverb=%d\n",
		buf[7]-24, buf[9]-50, buf[0x0B], buf[0x0D]+1, buf[0x0F]);
	printf("  Lower: ");
	c = buf[2];
	printf("%c%02d ", c==0 ? 'a' : c==1 ? 'b' : c==2 ? 'i' : 'r', buf[3]+1);
	printf("shift=%d tune=%d bender=%d assign=%d reverb=%d\n\n",
		buf[6]-24, buf[8]-50, buf[0x0A], buf[0x0C]+1, buf[0x0E]);
}
