/*
 * timbre.c
 * Dump a D-10 timbre.
 */

#include <stdio.h>
#define	TSIZE	0x08
unsigned char	buf[TSIZE];
unsigned char	name[128];

main(argc, argv) int argc; char *argv;
{
	register int i;

	if (argc == 1) {
		for (i = 0; i < 128; i++) {
			sprintf(name, "timbr%03d", i);
			printf("Timbre %c%c%c  midi=%3d  ",
				i < 64 ? 'A' : 'B',
				((i % 64) / 8) + '1',
				(i % 8) + '1',
				i);
			timbre(name);
		}
	} else
		timbre(argv[1]);
	exit(0);
}

timbre(s) char *s;
{
	register FILE *fp;
	register int c;

	if ((fp = fopen(s, "rb")) == NULL) {
		printf("open error on \"%s\"\n", s);
		exit(1);
	} else if (fread(buf, TSIZE, 1, fp) != 1) {
		printf("read error\n");
		exit(1);
	} else if ((c = getc(fp)) != EOF) {
		printf("expected EOF but read %x\n", c);
		exit(1);
	} else if (fclose(fp) == EOF) {
		printf("close error\n");
		exit(1);
	}
	c = buf[0];
	printf("%c%02d ", c==0 ? 'a' : c==1 ? 'b' : c==2 ? 'i' : 'r', buf[1]+1);
	printf("shift=%d tune=%d bender=%d assign=%d reverb=%d\n",
		buf[2]-24, buf[3]-50, buf[4], buf[5]+1, buf[6]);
}
