/*
 * timer.c
 * (c) 1989 by Stephen A. Ness.
 * Atari ST timer A routines.
 */

#include "timer.h"
#include <osbind.h>
#include <xbios.h>

long timerA;				/* millisecond counter */

/*
 * Pause for n seconds.
 * The timer had better be enabled.
 */
void
pause(n) int n;
{
	register unsigned long timen;

	for (timen = timerA + n * NTICKS; timerA < timen; )
		;
}

/*
 * Enable timer A to count in milliseconds from 0L.
 * The arguments to Xbtimer() are:
 *	0		timer A
 *	0x04		prescale divide by 50 (?)
 *	49		count down value (?)
 *	timerA_int	handler address
 * The ones marked (?) would be manifest constants
 * if I knew what they really meant.
 */
void
timerA_enab()
{
	Jdisint(MFP_TIMA);
	Xbtimer(0, 0x04, 49, timerA_int);
	timerA = 0L;
	Jenabint(MFP_TIMA);
}

/*
 * Disable the timer.
 * Disaster ensues unless the timer is disabled before program exit.
 */
void
timerA_disab()
{
	Jdisint(MFP_TIMA);
}

/* end of timer.c */
